seo:
  title: "De Jenkins à GitLab\_: une migration simple et efficace"
  description: >-
    Découvrez les avantages de la plateforme CI/CD GitLab et comment migrer
    facilement de Jenkins vers GitLab en suivant ce guide étape par étape.
  ogTitle: "De Jenkins à GitLab\_: une migration simple et efficace"
  ogDescription: >-
    Découvrez les avantages de la plateforme CI/CD GitLab et comment migrer
    facilement de Jenkins vers GitLab en suivant ce guide étape par étape.
  noIndex: false
  ogImage: images/blog/hero-images/AdobeStock_519147119.jpeg
  ogUrl: https://about.gitlab.com/blog/jenkins-to-gitlab-migration-made-easy
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/jenkins-to-gitlab-migration-made-easy
  schema: "\n                        {\n        \"@context\": \"https://schema.org\",\n        \"@type\": \"Article\",\n        \"headline\": \"De Jenkins à GitLab\_: une migration simple et efficace\",\n        \"author\": [{\"@type\":\"Person\",\"name\":\"Fernando Diaz\"}],\n        \"datePublished\": \"2024-02-01\",\n      }\n                  "
content:
  title: "De Jenkins à GitLab\_: une migration simple et efficace"
  description: >-
    Découvrez les avantages de la plateforme CI/CD GitLab et comment migrer
    facilement de Jenkins vers GitLab en suivant ce guide étape par étape.
  authors:
    - Fernando Diaz
  heroImage: images/blog/hero-images/AdobeStock_519147119.jpeg
  date: '2024-02-01'
  body: "GitLab est la plateforme DevSecOps alimentée par l'IA la plus complète. En effet, GitLab fournit toutes les fonctionnalités dont vous avez besoin pour planifier, développer et livrer des logiciels sécurisés plus rapidement, le tout au sein d'un seul et même outil.\n\nLes plateformes CI/CD unifiées éliminent les défis liés à l'intégration de multiples outils (approche DevOps DIY) pour gérer le cycle du développement logiciel (SDLC). À l'inverse, Jenkins n'étant pas une plateforme, des outils supplémentaires sont nécessaires pour compléter le SDLC. Cette approche DevOps DIY introduit une complexité supplémentaire liée à la chaîne d'outils, et génère plusieurs inconvénients dont les problèmes suivants\_:\n\n- Nécessité d'une assistance personnalisée pour l'intégration et l'orchestration des outils\n- Difficulté à tenir à jour/mettre à niveau/sécuriser des outils disparates\n- Impossibilité de mesurer correctement la transformation organisationnelle\n- Mauvaise expérience développeur\n- Coûts supplémentaires en lien avec la gestion, les délais et le budget\n- Perte de productivité\n- Changement de contexte et inefficacité en terme de collaboration\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/5LzKVyjOz5I0vMQPC9stXQ/3436cd5b44dff88b39c23b5edc1dbe18/jenkinsmigration-image1.png\" alt=\"Import project selection\">\n   <figcaption>DevOps DIY ou plateforme DevSecOps</figcaption>\n</figure>\n</center>\n<p></p>\n\nPour ces raisons, de nombreuses équipes de développement utilisant Jenkins envisagent de migrer vers une plateforme DevSecOps compète. Si vous recherchez une plateforme CI/CD puissante, fiable et sécurisée, GitLab est la plateforme idéale\_! GitLab propose une version gratuite ainsi que différents niveaux d'abonnement en fonction des besoins de votre entreprise. Pour en savoir plus sur nos offres et fonctionnalités, consultez notre [page de tarifs](https://about.gitlab.com/fr-fr/pricing/).\n\nDans cet article de blog, découvrez\_:\n- Comment planifier une migration\n- Comment migrer des dépôts depuis d'autres outils de gestion du code source (SCM) vers GitLab\n- Comment migrer des pipelines CI/CD de Jenkins vers GitLab\n- D'autres conseils liés à la migration\n\n### Planification de la migration\n\nAvant d'initier la migration de vos dépôts hébergés sur un autre outil vers GitLab CI/CD, vous devez élaborer un plan de migration. Cette étape technique importante vous permet de définir clairement vos attentes. Les outils CI/CD diffèrent par leur approche, leur structure et leurs spécificités techniques. Par conséquent, les migrations ne sont pas de simples transferts directs des données. Un plan de migration offre les avantages suivants\_:\n- Il définit et communique une vision claire de vos objectifs de migration, ce qui aide vos utilisateurs à comprendre le but de l'opération. Il permet aux personnes impliquées de comprendre dès le début du processus la valeur d'une telle opération.\n- Il vous permet de vous assurer d’obtenir l'aval des équipes de direction concernées pour faciliter cette démarche.\n- Il permet d'expliquer aux utilisateurs les changements à venir.\n- Il permet de trouver des moyens de séquencer ou de retarder certaines étapes de la migration pour éviter l'échec de la migration ou une migration partielle.\n- Il documente les avantages des améliorations apportées par GitLab CI/CD et met à jour votre mise en œuvre à chaque étape de la migration.\n\nUn plan de migration vous aide à mettre en place un processus fluide permettant de migrer progressivement vers GitLab, avec un minimum de perturbations, par exemple l'exécution simultanée de Jenkins et de GitLab ou le déplacement de certains projets de Jenkins vers GitLab.\n\n### Définition d'un processus de gestion du changement\n\nLe plan de migration doit inclure un processus efficace de gestion du changement. Il se peut que les développeurs, opérateurs informatiques, administrateurs cloud, ingénieurs de la sécurité et de la qualité n'aient pas d'expérience avec GitLab et ne sachent pas pourquoi vous ou vos équipes de direction avez choisi de réaliser cette migration.\n\nLes personnes que cela impacte doivent savoir\_:\n- __Pourquoi__ ce changement est nécessaire\n- __À quoi__ ressemblera le futur système\n- __Comment__ l'entreprise prévoir d'atteindre cet objectif\n- __Vers qui__ se tourner pour obtenir plus d'informations ou de l'aide \n\nÀ cette fin, vous devez réaliser les étapes ci-dessous afin de gérer efficacement le changement au sein des différentes équipes fonctionnelles\_: \n- __Analysez l'état actuel__\_: documentez les processus existants. Collectez des indicateurs qui serviront de base de référence. Identifiez ce qui fonctionne ou non avec l'approche CI/CD en interrogeant les membres clés de l'équipe. Documentez les défis que vous devez relever, et ce d'un point de vue quantitatif et qualitatif. Comme vous allez devoir expliquer les raisons de ce changement et votre vision, plus vous définirez clairement les problématiques que vous espérez résoudre, plus il vous sera facile d'obtenir l'adhésion de tous. \n- __Établissez une vision__\_: maintenant que vous avez décrit les points de friction actuels quantitativement avec des indicateurs de base et qualitativement (en vous basant sur les avis reçus des membres de votre équipe), communiquez une vision de l'état futur. Expliquez pourquoi c'est important (en vous référant aux indicateurs de réussite). Fournissez des démonstrations en direct et enregistrées du résultat attendu et de l'état actuel. Renforcez ce message par le biais de plusieurs canaux et médias\_: groupes de discussion, réunions rassemblant l'ensemble des acteurs de l'entreprise, notifications par e-mail, bannières sur la plateforme GitLab, par exemple.\n- __Formez le personnel__\_: investissez dans la [formation sur GitLab CI/CD](https://about.gitlab.com/services/education/gitlab-ci/) dispensée par un expert GitLab. Mesurez l'acquisition et la mémorisation des connaissances à l'aide des [certifications GitLab](https://levelup.gitlab.com/pages/certifications). \n- __Communiquez la roadmap et les ressources__\_: partagez avec les membres de votre équipe le calendrier prévu de la migration, les ressources mises à disposition pour faciliter la transition. Mentionnez également les ressources proposées par la communauté (groupes de discussion, forums de questions-réponses, horaires pour contacter les influenceurs et influenceuses GitLab, afin que votre équipe puisse poser des questions et obtenir de l'aide. Créez un système qui récompense les équipes qui effectuent rapidement la transition vers le nouvel outil plus tôt que prévu, et encouragez-les à partager leur expérience avec d'autres équipes similaires au sein de l'entreprise\_!\n\nSi vous mettez en place ces éléments au début de cette transition, cela sera de bon augure pour la réussite de la migration. \n\n### Définition des objectifs de migration\nAvant d'effectuer la migration, vous devez avoir une bonne compréhension de vos objectifs et de la façon de les atteindre. Voici par exemple certaines des questions auxquelles vous devez pouvoir répondre\_:\n- Quel est votre calendrier de migration\_?\n- Quelle est la configuration actuelle de votre serveur Jenkins\_?\n- Combien de projets sont concernés par la migration\_?\n- Quel est le degré de complexité de votre pipeline\_?\n- Nécessite-t-il des dépendances externes, plusieurs déclencheurs pour s'exécuter, exécute-t-il plusieurs processus en parallèle pour compiler le code, etc.\_?\n- Comment/où déployez-vous votre code\_?\n- Quel est le processus de revue de code/sortie des nouvelles versions et de déploiement du code\_?\n- Est-il intégré dans Jenkins ou dans un workflow distinct déclenché par Jenkins\_?\n- Quels artefacts de compilation ou binaires sont nécessaires au succès du pipeline\_?\n- Quels plug-ins sont utilisés par les jobs dans Jenkins aujourd'hui\_?\n- Quel logiciel est installé sur les agents Jenkins\_?\n- Quelle solution de gestion du code source (SCM) utilisez-vous actuellement\_?\n- Utilisez-vous des bibliothèques partagées dans vos jobs Jenkins\_?\n- Quelle méthode d'authentification est utilisée pour Jenkins (Basic Authentication, LDAP/AD, SSO)\_?\n- Y a-t-il d'autres projets auxquels vous devez accéder depuis votre pipeline\_?\n- Des identifiants de connexion dans Jenkins sont-ils utilisés pour accéder à des services externes\_?\n\nEn répondant à ces questions, vous saurez comment procéder à la migration, combien de temps durera cette opération et par où commencer. Une fois que vous avez élaboré un plan et que vous êtes conscient des attentes et des écueils possibles, vous pouvez commencer le processus de migration.\n\n### Prérequis à la migration\nUne fois que vous avez créé un plan de migration et répondu à toutes les attentes associées, vous pouvez commencer à configurer GitLab. Voici certains des prérequis suggérés pour la migration\_:\n- Familiarisez-vous avec GitLab. Documentez-vous sur les [fonctionnalités clés de GitLab CI/CD](https://docs.gitlab.com/ee/ci/index.html).\n- Suivez des tutoriels pour créer votre premier [pipeline GitLab](https://docs.gitlab.com/ee/ci/quick_start/index.html) et des [pipelines plus complexes](https://docs.gitlab.com/ee/ci/quick_start/tutorial.html) qui créent, testent et déploient un site statique.\n- Passez en revue la [liste des mots-clés de configuration .gitlab-ci.yml](https://docs.gitlab.com/ee/ci/yaml/index.html).\n- Configurez GitLab.\n- Testez votre instance GitLab.\n\nUne fois que vous avez compris le fonctionnement de GitLab et qu'une instance a été configurée, vous pouvez suivre votre plan de migration et commencer à déplacer des projets de Jenkins vers GitLab. Vérifiez que votre instance GitLab a été correctement configurée à l'aide des bonnes pratiques et des [architectures de référence](https://docs.gitlab.com/ee/administration/reference_architectures/) de GitLab.\n\n### Migration des dépôts vers GitLab\nL'un des principaux inconvénients est que Jenkins ne fournit pas de solution SCM. Si vous utilisez Jenkins, votre code doit être stocké dans une solution SCM distincte à laquelle Jenkins doit avoir accès. Comme GitLab dispose d'un SCM intégré, la migration depuis Jenkins vous permet également de migrer depuis la solution SCM que vous utilisiez, ce qui entraîne une réduction supplémentaire des coûts.\n\nGitLab fournit des outils pour vous permettre de déplacer facilement votre dépôt et ses métadonnées dans GitLab. Les outils d'importation suivants sont inclus et vous aideront à migrer vos projets vers GitLab\_:\n\n- [GitHub](https://docs.gitlab.com/ee/user/project/import/github.html)\n- [Autre instance GitLab](https://docs.gitlab.com/ee/user/project/settings/import_export.html)\n- [Bitbucket Cloud](https://docs.gitlab.com/ee/user/project/import/bitbucket.html)\n- [Bitbucket Server](https://docs.gitlab.com/ee/user/project/import/bitbucket_server.html)\n- [FogBugz](https://docs.gitlab.com/ee/user/project/import/fogbugz.html)\n- [Gitea](https://docs.gitlab.com/ee/user/project/import/gitea.html)\n- [Jira (Tickets uniquement)](https://docs.gitlab.com/ee/user/project/import/jira.html)\n- [Dépôt par fichier de manifeste](https://docs.gitlab.com/ee/user/project/import/manifest.html)\n- [Dépôt par URL](https://docs.gitlab.com/ee/user/project/import/repo_by_url.html)\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/gUQNsScnhxoM6Tdsgohwe/12bf77c1ecccd3cec714172d19086b13/jenkinsmigration-image2.png\" alt=\"GitHub to GitLab Repo Exporter\">\n   <figcaption>Outil d'exportation de dépôt de GitHub vers GitLab</figcaption>\n</figure>\n</center>\n<p></p>\n\nChaque outil d'importation importe différentes données d'un projet. Lisez la [documentation sur l'importation et la migration de projets](https://docs.gitlab.com/ee/user/project/import/) pour en savoir plus sur les outils d'importation fournis et comprendre quelles données sont migrées vers GitLab. De plus, vous pouvez [automatiser l'importation de groupes et de projets](https://docs.gitlab.com/ee/user/project/import/#automate-group-and-project-import) et créer une solution personnalisée pour mieux répondre aux besoins de votre entreprise\_:\n\n- [Services professionnels](https://about.gitlab.com/fr-fr/services/)\n- [Services de migration](https://gitlab.com/gitlab-org/professional-services-automation/tools/migration/congregate/-/blob/master/docs/using-congregate.md#quick-start)\n- [Foire aux questions sur la migration](https://gitlab.com/gitlab-org/professional-services-automation/tools/migration/congregate/-/blob/master/customer/famq.md)\n\n### Migration d'un dépôt\nLa migration d'un dépôt vers GitLab est facile grâce à nos outils d'importation intégrés. Dans cet exemple, nous allons vous expliquer comment copier un dépôt de GitHub vers GitLab ainsi que [ses ressources](https://docs.gitlab.com/ee/user/project/import/github.html#imported-data) (tickets, pull requests, jalons et ainsi de suite). Afin de migrer un dépôt d'une autre instance GitHub vers GitLab, vous pouvez suivre les étapes ci-dessous\_:\n\n1. Dans la barre latérale de gauche, en haut, sélectionnez **Créer (+)**.\n2. Sélectionnez **Nouveau projet/dépôt** dans la section Dans GitLab.\n3. Sélectionnez **Importer un projet**.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/6muFotwwYlK55wSLoUIfX2/f23ccd84c0be156f4ccb30e461c9f358/jenkinsmigration-image3.png\" alt=\"Import project selection\">\n   <figcaption>Sélection de l'option Importer un projet</figcaption>\n</figure>\n</center>\n<p></p>\n\n4. Cliquez sur le bouton **GitHub**.\n    - Si vous utilisez GitLab Self-Managed, vous devez [activer l'outil d'importation GitHub](https://docs.gitlab.com/ee/administration/settings/import_and_export_settings.html#configure-allowed-import-sources).\n    - Les autres outils d'importation peuvent être lancés de la même manière.\n5. Vous pouvez utiliser l'une des deux options ci-dessous\_:\n    - Autoriser avec OAuth de GitHub\_: sélectionnez **Autoriser avec GitHub**.\n    - Utiliser un jeton d'accès personnel GitHub\_:\n       - Accédez à la page [https://github.com/settings/tokens/new](https://github.com/settings/tokens/new).\n       - Dans le champ **Note**, saisissez une description du token.\n - Sélectionnez la portée du dépôt.\n       - En option, pour importer des collaborateurs, sélectionnez la portée **read:org**.\n       - Cliquez sur le bouton **Générer un token**.\n       - Sur la page Importation depuis GitLab, dans le champ Jeton d'accès personnel, collez le jeton d'accès personnel GitHub.\n6. Cliquez sur le bouton **Authentifier**.\n7. Sélectionnez les éléments que vous souhaitez migrer.\n8. Sélectionnez les projets que vous souhaitez migrer et leur destination.\n9. Appuyez sur le bouton **Importer**.\n\nLe projet importé doit maintenant être disponible dans votre espace de travail. Pour obtenir des conseils supplémentaires sur la migration de GitHub vers GitLab, regardez cette vidéo\_:\n\n<\_!-- blank line -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/0Id5oMl1Kqs?si=TQ5HI9aMwtzJMiMi\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- blank line -->\n\nUne fois que vous avez terminé la migration du dépôt, vous pouvez configurer votre pipeline Jenkins pour tirer parti du fichier Jenkinsfile dans GitLab. Pour ce faire, définissez l'URL du dépôt sur le projet que vous venez tout juste d'importer via le menu de configuration du pipeline Jenkins\_:\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/5zdnTVpO1t2PZQ4bIdaTlm/ebcfd34ceb86053408ad0991da1aa17a/jenkinsmigration-image4.png\" alt=\"Jenkins Pipeline SCM settings\">\n   <figcaption>Paramètres SCM du pipeline Jenkins</figcaption>\n</figure>\n</center>\n<p></p>\n\nCette opération est utile pendant la phase de migration initiale du dépôt et vous permet d'utiliser Jenkins et GitLab en parallèle. Vous évitez ainsi toute interruption de service pendant que vous travaillez sur la migration de la fonctionnalité CI/CD.\n\nDe plus, vous pouvez utiliser le [plug-in Jenkins GitLab](https://plugins.jenkins.io/gitlab-plugin/) pour faciliter la migration. Ce plug-in permet à GitLab de déclencher et d'obtenir le statut des compilations Jenkins.\n\n### Migration des pipelines CI/CD\nUne fois que vous avez migré vos dépôts vers GitLab, vous pouvez également migrer vos pipelines Jenkins. Bien qu'assez simple, ce processus nécessite une bonne compréhension des concepts et de la syntaxe Jenkins et GitLab.\n\nJenkins fournit deux types de syntaxe pour la définition des pipelines\_: une syntaxe déclarative et une syntaxe scriptée. Dans ce guide, nous décrirons la migration à partir des pipelines déclaratifs, car ils sont les plus couramment utilisés.\n\n### Migration de pipeline étape par étape\nDans ce tutoriel, nous analyserons un Jenkinsfile (Groovy) ainsi qu'un fichier de configuration GitLab CI/CD (YAML) qui compile, teste et déploie un microservice écrit en Golang. Nous activerons ensuite le pipeline dans GitLab et observerons le résultat. Le pipeline\_:\n\n- Utilisera l'image de conteneur Golang avec le tag **alpine**\n- Exécutera un job pour compiler le code Golang en un fichier binaire exécutable\n   - Stockera le fichier exécutable compilé en tant qu'artefact\n- Exécutera un job pour lancer les tests unitaires\n- Exécutera un job pour effectuer le déploiement sur l'environnement de préproduction\n   - Ne s'exécutera que si la validation cible la branche de **préproduction**\n   - S'exécutera uniquement après la réussite de l'étape de **test**\n   - Utilisera l'artefact exécutable compilé du job précédent\n\nVous trouverez ci-dessous les définitions de pipeline Jenkins et GitLab accompagnées de commentaires descriptifs. Vous pouvez observer le pipeline en action dans le [projet de migration Meow](https://gitlab.com/gitlab-de/projects/blogs/meow-migration).\n\nVoici un fichier Jenkinsfile écrit en Groovy\_:\n\n```  \n// The top-level of the declarative\n// pipeline.\npipeline {\n\n  // Defines the default agent to use\n  // when it is not explicitly defined\n  // in a job.\n    agent any\n\n  // Defines the stages that will run\n  // in numerical order. Each stage\n  // only runs one job.\n    stages {\n\n    // Defines the name of the stage\n        stage('build') {\n      // Defines the container image to\n      // use for this job, overwriting\n      // the default 'agent any'.\n      // The Jenkins Docker plugin\n      // must be configured for this\n      // to run.\n            agent { docker 'golang:alpine' }\n\n      // Defines the sequence of steps\n      // to execute when the stage is\n      // run.\n            steps {\n                sh 'go build -o bin/meow-micro'\n                sh 'chmod +x bin/meow-micro'\n            }\n\n      // The steps to run after the\n      // stage completes.\n            post {\n              always {\n\n        // Stores the stage artifacts\n        // generated for use in another\n        // job.\n                archiveArtifacts artifacts: 'bin/meow-micro'\n                onlyIfSuccessful: true\n              }\n            }\n        }\n\n    stage('test') {\n            agent { docker 'golang:alpine' }\n            steps {\n                sh 'go test .'\n            }\n        }\n\n        stage('deploy') {\n      // Defines conditions which must\n      // be met in order for the job to\n      // execute. In this case the\n      // deploy job will only run on the \n      // staging branch.\n            when {\n              branch 'staging'\n            }\n            steps {\n                echo 'Deploying meow-micro to staging'\n        // Uses the artifact stored in\n        // the build stage.\n                sh './bin/meow-micro'\n            }\n        }\n    }\n}\n```\n\nVoyons maintenant comment créer la même fonctionnalité dans GitLab\_:\n\n```\n# Defines the default image to use\n# when it is not explicitly defined in\n# a job.\ndefault:\n  image: alpine:latest\n\n# Defines the order to run the stages.\n# Each stage can have multiple jobs.\nstages:\n  - build\n  - test\n  - deploy\n\n# Defines the name of the job\ncreate-binary:\n # Defines the stage the job will run in\n  stage: build\n # Defines the container image to use\n # for this job, overwriting default.\n  image: golang:alpine\n # Defines the sequence of steps to\n # execute when the job is run.\n  script:\n    - go build -o bin/meow-micro\n    - chmod +x bin/meow-micro\n # Stores the job artifacts generated\n # for use in another job.\n  artifacts:\n    paths:\n      - bin/meow-micro\n    expire_in: 1 week\n\nunit-tests:\n  stage: test\n  image: golang:alpine\n  script:\n    - go test .\n # Defines commands to run after the\n # job.\n after_script:\n  - echo \"Tests Complete\"\n\nstaging-deploy:\n  stage: deploy\n # Defines commands to run before the\n # actual job.\n  before_script:\n    - apk update\n  script:\n    - echo \"Deploying meow-micro to staging environment\"\n    - ./bin/meow-micro\n # Defines conditions which must be met\n # in order for this job to execute. In\n # this case the staging-deploy job will \n # only run on the staging branch.\n  rules:\n    - if: $CI_COMMIT_BRANCH == 'staging'\n # Allows the artifact stored in the\n # build job to be used in this job.\n  artifacts:\n    paths:\n      - bin/meow-micro\n```\n\nComme vous l'avez peut-être remarqué, il existe de nombreuses similitudes entre les syntaxes Jenkins et GitLab, ce qui simplifie la migration du pipeline. Bien que l'exemple ci-dessus fournisse une vue d'ensemble basique, assurez-vous de consulter la liste complète des [comparaisons de fonctionnalités et de concepts](https://docs.gitlab.com/ee/ci/migration/jenkins.html#comparison-of-features-and-concepts) entre les deux outils.\n\nMaintenant que nous comprenons comment transposer Jenkins à GitLab, nous pouvons commencer à créer un pipeline avec la même fonctionnalité dans GitLab. Pour effectuer la migration du pipeline CI/CD, suivez les étapes suivantes\_:\n\n##### 1. Ouvrez le dépôt que vous avez migré vers GitLab dans la section ci-dessus.\n- Dans la barre latérale de gauche, en haut, sélectionnez **Rechercher ou accéder...**.\n- Localisez votre projet.\n\n##### 2. Ouvrez l'[éditeur de pipeline](https://docs.gitlab.com/ee/ci/pipeline_editor/).\n- Dans la barre latérale de gauche, sélectionnez **Compilation > Éditeur de pipeline**.\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/6Fh56xIwkPHkW92c0bQPrd/8d3249b5a4ec8861d9e03d60c9dd43bc/jenkins_migration_-_image5.png\" alt=\"Pipeline editor menu\">\n   <figcaption>Menu de l'Éditeur de pipeline</figcaption>\n</figure>\n</center>\n<p></p>\n\n- Cliquez sur le bouton **Configurer le pipeline**.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/7v7mwgAksmxksFa03HFQaT/87b2357ba4dadd47414aa2fa5279cfa8/jenkins_migration_-_image_6.png\" alt=\"Configure pipeline selection\">\n   <figcaption>Sélection du bouton Configurer le pipeline</figcaption>\n</figure>\n</center>\n<p></p>\n\n##### 3. Complétez le fichier [.gitlab-ci.yml](https://docs.gitlab.com/ee/ci/yaml/).\n- Ajoutez le code du pipeline GitLab CI. \n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/awxnIcwk9XO8ud2eLC9zL/9e848ad4c50afd0e9375cb718ebd7ffd/jenkins_migration_-_image_7.png\" alt=\"Pipeline editor input\">\n   <figcaption>Saisie dans l'éditeur de pipeline</figcaption>\n</figure>\n</center>\n<p></p>\n\n- Vérifiez que la syntaxe est correcte.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/33kZBJOhkB1RP6fztcdJjg/6369862e9da46c01a47c0b30973c24c1/jenkinsmigration-image8.png\" alt=\"Pipeline syntax validation\">\n   <figcaption>Validation de la syntaxe du pipeline</figcaption>\n</figure>\n</center>\n<p></p>\n\n- Visualisez le pipeline.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/63iAMbBXaG1E3rNsHBFmIT/8514faad4e1fcebfeef4c03c3ec94be0/jenkinsmigration-image9.png\" alt=\"Pipeline visualization\">\n   <figcaption>Visualisation du pipeline</figcaption>\n</figure>\n</center>\n<p></p>\n\n##### 4. Validez le fichier dans la branche principale.\n- Ajoutez un message de validation.\n- Assurez-vous que la branche est définie sur la branche principale.\n- Cliquez sur le bouton Valider les modifications.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/wxPlfWyZgpH9PbcaWFBij/6573f24c02e906864bd376d7a57c6f57/jenkins_migration_-_image_10.png\" alt=\"Commit changes dialog\">\n   <figcaption>Boîte de dialogue Valider les modifications</figcaption>\n</figure>\n</center>\n<p></p>\n\nUne fois le fichier fusionné, le pipeline défini s'exécute. Vous pouvez revenir à votre projet et [observer le pipeline](https://docs.gitlab.com/ee/ci/pipelines/#view-pipelines) en action en le sélectionnant sur la page **Compilation > Pipelines** de votre projet. Comme il a été exécuté sur la branche **principale**, vous ne verrez que les jobs **create-binary** et unit-tests. Le job **staging-deploy** s'exécute uniquement sur la branche de préproduction.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/75Hpi9YaibGMKhFW0CMKYC/2904c9228796a4dfea72f1095ae3e4af/jenkins_migration_-_image_11.png\" alt=\"Pipeline running on main branch\">\n   <figcaption>Pipeline en cours d'exécution sur la branche principale</figcaption>\n</figure>\n</center>\n<p></p>\n\nSi nous créons une branche de préproduction, le pipeline suivant s'exécute.\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/wXStneGABfBbOEVJopYGx/8fbce8458b56222972b97dba0b92bafc/jenkinsmigration-image12.png\" alt=\"Pipeline running on staging branch\">\n   <figcaption>Pipeline en cours d'exécution sur la branche de préproduction</figcaption>\n</figure>\n</center>\n<p></p>\n\nEn cliquant sur un job, nous pouvons voir la sortie associée\_:   \n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/16rVbOujDloJyUV2MxVTLB/a37a59dcf8c7f51f5db03e9a8e593af7/jenkinsmigration-image13.png\" alt=\"create-binary job output\">\n   <figcaption>sortie du job create-binary</figcaption>\n</figure>\n</center>\n<p></p>\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/3ZbTMmzGVX6JFI6Lh74HZg/deafe6803e5e06f889dc6bca973ec3b0/jenkinsmigration-image14.png\" alt=\"unit-tests job output input\">\n   <figcaption>entrée/sortie du job unit-tests</figcaption>\n</figure>\n</center>\n<p></p>\n\n<center>\n<figure>\n   <img src=\"//images.ctfassets.net/r9o86ar0p03f/4HWVV4CYC16YqteCtDQUfo/733afa018f81720b4da3b5cae231f98a/jenkinsmigration-image15.png\" alt=\"staging-deploy job output\">\n   <figcaption>sortie du job staging-deploy</figcaption>\n</figure>\n</center>\n<p></p>\n\nL'artefact est stocké dans le job create-binary et utilisé dans le job staging-deploy. La migration d'un pipeline de Jenkins vers GitLab est aussi simple que cela\_!\n\n### Autres conseils à suivre lors de la migration\nVoici quelques conseils pratiques pour simplifier le processus de déploiement\_:\n\n- N'essayez pas de répliquer les tâches dans des jobs GitLab une à une. Prenez le temps de comprendre la fonction du pipeline actuel et quel problème il résout.\n\n- Certains jobs Jenkins peuvent être trop complexes pour être migrés immédiatement vers GitLab. Il peut donc s'avérer pratique d'utiliser le [plug-in Jenkins GitLab](https://plugins.jenkins.io/gitlab-plugin/) pour lancer les pipelines Jenkins et afficher leurs résultats directement à partir de GitLab. Cela vous permet de migrer lentement certaines actions vers GitLab jusqu'à ce que l'ensemble du pipeline puisse être déplacé.\n\n- Mettez en œuvre des [scanners de sécurité et une vérification de la qualité du code](https://docs.gitlab.com/ee/user/application_security/) à l'aide de modèles intégrés fournis par GitLab dès le départ. Cela vous permettra d'intégrer la sécurité en amont et ainsi de réduire le risque d'atteinte à la sécurité.\nNe compliquez pas trop la configuration CI/CD et essayez d'utiliser les avantages de chaque fonctionnalité sans tarder. Modularisez le code et implémentez-le en petites itérations.\n\n- Mettez en œuvre le suivi et la gouvernance dès le départ.\n\n- Sachez que GitLab Runner (Go) peut se comporter différemment de l'agent Jenkins (Java). L'utilisation du processeur et la consommation de mémoire peuvent différer. Pensez à effectuer des comparaisons au fil du temps.\n\n- Envisagez d'investir dans des mécanismes de mise à l'échelle automatique et arrêtez les ressources inutiles le week-end ou en dehors des heures de travail.\n\n- Modernisez le développement d'applications en conteneurisant vos jobs. Les jobs Jenkins ne sont pas actuellement exécutés sur un conteneur, mais sur un agent Jenkins s'exécutant en tant que machine virtuelle.\n\nBien que cette liste ne soit pas exhaustive, elle constitue un bon point de départ. Si vous avez besoin d'une aide supplémentaire, GitLab fournit des [services professionnels](https://about.gitlab.com/fr-fr/get-help/) pour vous aider dans votre parcours de migration.\n\n### En savoir plus\nMerci de votre intérêt pour cet article\_! J'espère que ce guide vous a aidé à comprendre clairement les avantages de migrer de Jenkins vers GitLab, et comment procéder. Vous hésitez encore\_? [Essayez GitLab avec notre essai gratuit](https://about.gitlab.com/fr-fr/free-trial/) et découvrez les avantages d'une plateforme DevSecOps\_!\n\nVoici quelques ressources supplémentaires sur GitLab, les avantages d'une plateforme DevSecOps et le processus de migration depuis Jenkins\_:\n\n- [Migration depuis Jenkins](https://docs.gitlab.com/ee/ci/migration/jenkins.html)\n- [Planification d'une migration](https://docs.gitlab.com/ee/ci/migration/plan_a_migration.html)\n- [Outils d'importation de projets GitLab](https://docs.gitlab.com/ee/user/project/import/)\n- [Tutoriel\_: Migration facile de GitHub vers GitLab](https://about.gitlab.com/blog/2023/07/11/github-to-gitlab-migration-made-easy/)\n- [Vidéo\_: Migration facile de GitHub vers GitLab](https://youtu.be/0Id5oMl1Kqs?feature=shared)\n- [De Jenkins à GitLab\_: le guide ultime pour moderniser votre environnement CI/CD](https://about.gitlab.com/blog/2023/11/01/jenkins-gitlab-ultimate-guide-to-modernizing-cicd-environment/)\n"
  category: DevSecOps
  tags:
    - CI/CD
    - DevSecOps
config:
  slug: jenkins-to-gitlab-migration-made-easy
  featured: false
  template: BlogPost
